unit atmintis;

interface
  function  dydis: integer;
  { graina N, kai atminties talpa 2^N bait }
  function  skaicius: integer;
  { dar neatlikt operacij skaiius }
  procedure oper (var op: char; var nr, b: longint);
  { nusako tolesn operacij;
    op = 'R' - raymo operacija; nr - raomos operacijos numeris;
               b - raom duomen kiekis ba.
    op = 'T' - trynimo operacija; nr - ios raomos operacijos metu raytus duomenis
               reikia trinti; b - neapibrta reikm.}
  procedure jungti (i: longint);
  { sujungia i-j blok su (i+1) -uoju }
  procedure pusiau (i: longint);
  { padalija i-j blok  du vienodo dydio blokus }
  procedure rasyti (nr, b: longint);
  { rao b bait  blok, kurio numeris nr }
  procedure trinti (nr: longint);
  { itrina duomenis i bloko, kurio numeris nr }
  procedure baigti;
  { ubaigiamas darbas }


implementation
   const PR = 'PROG.CMD';
         RZ = 'PROG.REZ';
         MAX_BL = 1024; { maksimalus blok skaiius }
   type blokas = record
                   bloko_dydis: longint;
                   rasymo_op_nr: longint;
                 end;
        atmint = array [1..MAX_BL] of blokas;

   { emiau aprayti globalieji kintamieji }
   var N,   { atminties dydis yra 2^N }
       bloku_kiekis, { atminties blok kiekis }
       op_liko,   { tiek operacij dar reikia vykdyti }
       op_kiekis: longint;
       atm: atmint;
       operac: char; { kokia tolesn operacija atliekama }
       num, ba: longint; { koks tos operacijos numeris }
                         { ir kiek bait bus raoma }
       f, g: text; { byla su operacijomis }
       ivykdyta: boolean; { ar vykdyta prie tai buvusi opercija }

  procedure baigti_darba (i: longint);
  begin
    close (f); { udaroma pradini duomen byla }
    writeln (g);
    case i of
      0: begin
           writeln (g, '   Darbas baigtas skmingai.');
           writeln (g, '   vykdyta ', op_kiekis-op_liko,
                    ' operacij i ', op_kiekis);
         end;
      1: writeln (g, '   Nevykdyta prie tai buvusi operacija');
      2: writeln (g, '   Atliktos visos operacijos, taiau moksleivio programa ',
                   'kreipsi  procedr "oper".');
      3: writeln (g, '   Blokas nerastas');
      4: writeln (g, '   Bandyta sujungti skirtingo dydio blokus');
      5: writeln (g, '   Bandyta sujungti netuius blokus');
      6: writeln (g, '   Bandoma suskaidyti nedalom blok');
      7: writeln (g, '   Bandoma suskaidyti netui blok');
      8: writeln (g, '   Reikia atlikti raymo, ne trynimo operacij');
      9: writeln (g, '   Neteisingas raom bait skaiius');
     10: writeln (g, '   Duomenys raomi  uimt blok');
     11: writeln (g, '   raomi duomenys netelpa  blok');
     12: writeln (g, '   Duomenys trinami ne i to bloko');
     13: writeln (g, '   Reikia atlikti ne raymo, o trynimo operacij');
     14: writeln (g, '   Operacija jau vykdyta');
     15: writeln (g, '   Per didelis blokas duomenims');
    end;
    { atspausdiname atminties situacij }
    writeln (g);
    writeln (g, 'Atmintis: 2^', N);
    writeln (g, 'Bloko Nr     Bloko dydis     Operacijos Nr');
    for i := 1 to bloku_kiekis do
      writeln (g, i: 5, '        [ 2^ ', atm[i].bloko_dydis,
                  '    ]  :     ', atm[i].rasymo_op_nr: 4);
    close (g);
    halt (0);
  end; { baigti_darb }

  procedure pranesimas (i: integer);
  begin
    if i <> 6
      then write (g, 'Operacija Nr. ',  op_kiekis - op_liko + 1, ': ');
    case i of
      0: writeln (g, '  atminties dydis            gerai');
      1: writeln (g, '  operacij skaiius         gerai');
      2: write (g, '  naujos komandos skaitymas ');
      3: write (g, '  sujungimas                ');
      4: write (g, '  dalijimas                 ');
      5: write (g, '  trynimas                  ');
      6: writeln (g, ' gerai');
      7: write (g, '  raymas                   ');
      8: write (g, 'darbo pabaiga:            gerai')
    end;
  end; { praneimas }

  function dydis: integer;
  begin
    dydis := N;
    pranesimas (0);
  end; { dydis }

  function skaicius: integer;
  begin
    skaicius := op_liko;
    pranesimas (1);
  end; { end }

  procedure oper (var op: char; var nr, b: longint);
    var d:longint;
  begin
    pranesimas (2);
    { jei nevykdyta prie tai buvusi operacija }
    if not ivykdyta
       then baigti_darba (1);
    { jei visos operacijos jau atliktos }
    if op_liko = 0
       then baigti_darba (2);
    { jei dar yra neatlikt operacij }
    readln (f, op, nr, b);
    operac := op; num := nr; ba := b;
    ivykdyta := false;
    pranesimas (6);
  end; { oper }

  procedure jungti (i: longint);
    var j: longint;
  begin
    pranesimas (3);
    { patikrinama, ar jungimo operacija korektika }
    if (i < 1) or (i > bloku_kiekis - 1)
       then baigti_darba (3)
    else if (atm[i].bloko_dydis <> atm[i+1].bloko_dydis)
       then baigti_darba (4)
    else if (atm[i].rasymo_op_nr <> 0) or (atm[i+1].rasymo_op_nr <> 0)
       then baigti_darba (5);
    { jei korektika - sujungiami blokai }
    atm[i].bloko_dydis := atm[i].bloko_dydis + 1;
    for j := i+1 to bloku_kiekis-1 do
      begin
        atm[j].bloko_dydis  := atm[j+1].bloko_dydis;
        atm[j].rasymo_op_nr := atm[j+1].rasymo_op_nr;
      end;
     bloku_kiekis := bloku_kiekis - 1;
     pranesimas (6);
  end; { jungti }

  procedure pusiau (i: longint);
    var j: longint;
  begin
    pranesimas (4);
    { patikrinama, ar skaidymo  dvi dalis operacija korektika }
    if (i < 1) or (i > bloku_kiekis)
       then baigti_darba (3)
    else if atm[i].bloko_dydis = 0
       then baigti_darba (6)
    else if atm[i].rasymo_op_nr <> 0
       then baigti_darba (7);
    { jei korektika - blokas suskaidomas }
    atm[i].bloko_dydis := atm[i].bloko_dydis - 1;
    for j := bloku_kiekis downto i+1 do
      begin
        atm[j+1].bloko_dydis  := atm[j].bloko_dydis;
        atm[j+1].rasymo_op_nr := atm[j].rasymo_op_nr;
      end;
    atm[i+1].bloko_dydis  := atm[i].bloko_dydis;
    atm[i+1].rasymo_op_nr := atm[i].rasymo_op_nr;
    bloku_kiekis := bloku_kiekis + 1;
    pranesimas (6);
  end; { pusiau }

  procedure rasyti (nr, b: longint);
    var reikia, laips: longint;
  begin
    pranesimas (7);
    { patikrinama, ar viskas korektika }
    if (nr < 1) or (nr > bloku_kiekis) { ar toks blokas egzistuoja }
       then baigti_darba (3)
    else if atm[nr].rasymo_op_nr <> 0 { ar tas blokas laisvas }
       then baigti_darba (10)
    else if (operac <> 'R')          { ar tai tikrai raymo operacija }
       then baigti_darba (8)
    else if b <> ba    { ar raoma tiek bait kiek reikia }
       then baigti_darba (9)
    else if ivykdyta
       then baigti_darba (14)
    else begin         { ar uteks atminties }
           { apskaiiuosime kiek reikia atminties }
           reikia := 0;
           laips := 1;
           while b > laips do
             begin
               laips := laips * 2;
               reikia := reikia + 1;
             end;
           if reikia > atm[nr].bloko_dydis
              then baigti_darba (11)
              else if reikia < atm[nr].bloko_dydis
                      then baigti_darba (15);
         end;
    { jei viskas gerai - atliekame operacij }
    ivykdyta := true;
    atm[nr].rasymo_op_nr := num;
    op_liko := op_liko - 1;
    pranesimas (6);
  end; { rayti }

  procedure trinti (nr: longint);
    var kur_toks_blokas:longint;
        i:longint;
  begin
    pranesimas (5);
    { patikrinama, ar viskas korektika }
    if (nr < 1) or (nr > bloku_kiekis) { ar toks blokas egzistuoja }
       then baigti_darba (3)
    else if (atm[nr].rasymo_op_nr <> num) and { ar t blok reikia trinti }
            (atm[nr].rasymo_op_nr <> 0)
       then baigti_darba (12)
    else if (operac <> 'T')          { ar tai tikrai trynimo operacija }
       then baigti_darba (13)
    else if ivykdyta
       then baigti_darba (14);
    { atliekama operacija }
    atm[nr].rasymo_op_nr := 0;
    op_liko := op_liko - 1;
    ivykdyta := true;
    pranesimas (6);
  end; { trinti }

  procedure baigti;
  begin
    baigti_darba (0);
    pranesimas (8);
  end; { baigti }

begin
  assign (g, RZ);
  rewrite (g);
  assign (f, PR);
  reset (f);
  readln (f, N, op_kiekis);
  op_liko := op_kiekis; { reikia vykdyti visas operacijas }
  bloku_kiekis := 1; { atmint sudaro vienas blokas }
  { suformuojame pirmj blok }
  atm[1].bloko_dydis := N;
  atm[1].rasymo_op_nr:=0; { blokas tuias }
  ivykdyta := true;
end.
